#!/usr/bin/perl

# Author: Konstantin Kuzov aka NoSFeRaTU (2:5019/40)
# This source distributed under GPL License.

use strict;
use warnings;
use XML::Simple;
use LWP::Simple ();
use Data::Dump qw(dump);
use Encode;

my $xmlStr = LWP::Simple::get('http://informer.gismeteo.ru/xml/26781_1.xml');
my $xs = new XML::Simple();
my $ref = $xs->XMLin($xmlStr, keyattr => []);

#dump($ref->{REPORT}->{TOWN});
my @months = ("","","","","","","","","","","","");
my @time = ("", "", "", "" );
my @days = ("ᥭ", "쭨", "୨", "।", "⢥", "⭨", "㡡" );
my @wind = ("", "-", "", "-", "", "-","","-" );
my @cloudiness = ("᭮", "筮", "筮", "୮");
my @precipitation = (" "," "," ","","","","","஧"," ", " ᠤ");

print "Ŀ\n";
print "                                                                       \n";
print "Ĵ\n";

print " த               ";
my $town = $ref->{REPORT}->{TOWN}->{sname};
$town =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
$town = Encode::encode('cp866', Encode::decode('cp1251', $town));
printf " %-40s %2d, %2d ",$town,$ref->{REPORT}->{TOWN}->{latitude},$ref->{REPORT}->{TOWN}->{longitude};
print "\nĴ";

print "\n ६               ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%2d %3s %5s ",$weather->{day},$months[$weather->{month}-1],$time[$weather->{tod}-1];
}
print "\n           ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%12s ",$days[$weather->{weekday}-1];
}
print "\n 筮          ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%12s ",$cloudiness[$weather->{PHENOMENA}->{cloudiness}];
}
print "\n ᠤ              ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%12s ",$precipitation[$weather->{PHENOMENA}->{precipitation}-1];
}
print "\n ࠢ    ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%12s ",$wind[$weather->{WIND}->{direction}-1];
}
print "\n            ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%8s / ",$weather->{WIND}->{min}."-".$weather->{WIND}->{max};
}
print "\n ⬮୮ ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%9s  ",$weather->{PRESSURE}->{min}."-".$weather->{PRESSURE}->{max};
}
print "\n T  ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%9s C ",$weather->{TEMPERATURE}->{min}."-".$weather->{TEMPERATURE}->{max};
}
print "\n ⭮.   ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%10s %% ",$weather->{RELWET}->{min}."-".$weather->{RELWET}->{max};
}
print "\n              ";
for my $weather (@{$ref->{REPORT}->{TOWN}->{FORECAST}}) {
	printf "%9s C ",$weather->{HEAT}->{min}."-".$weather->{HEAT}->{max};
}
print "\n\n";

